image: node:latest

stages:
  - init
  - deploy

install_dependencies:
  stage: init
  artifacts:
    paths:
     - node_modules/
    expire_in: 30 mins
  before_script:
    - npm install -g serverless
  script:
   - npm install

dev-deploy: 
  stage: deploy
  before_script:
    - curl https://bootstrap.pypa.io/get-pip.py -o get-pip.py
    - python get-pip.py
    - pip install awscli
    - npm config set prefix /usr/local
    - apt-get update && apt-get install -y curl gnupg
    - curl -qsL https://github.com/mozilla/sops/releases/download/v3.5.0/sops-v3.5.0.linux -o /usr/local/bin/sops
    - chmod +x /usr/local/bin/sops
    - cat $KEY | gpg --batch --import
    - echo $PASSPHRASE | gpg --batch --always-trust --yes --passphrase-fd 0 --pinentry-mode loopback -s $(mktemp)
  script:
    - sops -d -i config/config.dev.json
    - export KEY="$(cat config/config.dev.json | python -c "import sys, json; print json.load(sys.stdin)['AWS_ACCESS_KEY']")"
    - export SECRET="$(cat config/config.dev.json | python -c "import sys, json; print json.load(sys.stdin)['AWS_SECRET_KEY']")"
    - export BUCKET="$(cat config/config.dev.json | python -c "import sys, json; print json.load(sys.stdin)['AWS_S3_BUCKET_NAME']")"
    - aws configure set aws_access_key_id $KEY
    - aws configure set aws_secret_access_key $SECRET
    - npm run build
    - aws s3 sync ./build $BUCKET --delete --acl public-read
  only:
    refs:
     - /^integration.*$/